## telegram-desktop 1.9.14+ds

=== Telegram/CMakeLists.txt ===
# This file is part of Telegram Desktop,
# the official desktop application for the Telegram messaging service.
#
# For license and copyright information please follow this link:
# https://github.com/telegramdesktop/tdesktop/blob/master/LEGAL

add_executable(Telegram WIN32 MACOSX_BUNDLE)
init_target(Telegram)

add_subdirectory(lib_rpl)
add_subdirectory(lib_crl)
add_subdirectory(lib_base)
add_subdirectory(lib_ui)
add_subdirectory(lib_tl)
if (NOT DESKTOP_APP_DISABLE_SPELLCHECK)
    add_subdirectory(lib_spellcheck)
endif()
add_subdirectory(lib_storage)
add_subdirectory(lib_lottie)
add_subdirectory(lib_qr)
add_subdirectory(codegen)

include(CheckCXXSourceCompiles)
include(lib_ui/cmake/generate_styles.cmake)
include(cmake/generate_lang.cmake)
include(cmake/generate_numbers.cmake)

get_filename_component(src_loc SourceFiles REALPATH)
get_filename_component(res_loc Resources REALPATH)

include(cmake/telegram_options.cmake)
include(cmake/lib_export.cmake)
include(cmake/lib_ffmpeg.cmake)
include(cmake/lib_mtproto.cmake)
include(cmake/lib_scheme.cmake)
include(cmake/lib_tgvoip.cmake)

set(style_files
    boxes/boxes.style
    calls/calls.style
    dialogs/dialogs.style
    export/view/export.style
    history/history.style
    info/info.style
    intro/intro.style
    media/view/media_view.style
    media/player/media_player.style
    overview/overview.style
    passport/passport.style
    profile/profile.style
    settings/settings.style
    chat_helpers/chat_helpers.style
    window/window.style
)

set(dependent_style_files
    ${submodules_loc}/lib_ui/ui/colors.palette
    ${submodules_loc}/lib_ui/ui/basic.style
    ${submodules_loc}/lib_ui/ui/layers/layers.style
    ${submodules_loc}/lib_ui/ui/widgets/widgets.style
)

generate_styles(Telegram ${src_loc} "${style_files}" "${dependent_style_files}")
generate_lang(Telegram ${res_loc}/langs/lang.strings)
generate_numbers(Telegram ${res_loc}/numbers.txt)

set_target_properties(Telegram PROPERTIES AUTOMOC ON AUTORCC ON)

if (DESKTOP_APP_USE_PACKAGED)
    set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
    find_package(Threads)

    target_link_libraries(Telegram
    PRIVATE
        ${CMAKE_DL_LIBS}
        Threads::Threads
    )
endif()

if (LINUX AND NOT TDESKTOP_DISABLE_DBUS_INTEGRATION)
    target_link_libraries(Telegram
    PRIVATE
        desktop-app::external_statusnotifieritem
        desktop-app::external_dbusmenu_qt
    )
endif()

target_link_libraries(Telegram
PRIVATE
    tdesktop::lib_mtproto
    tdesktop::lib_scheme
    tdesktop::lib_export
    desktop-app::lib_base
    desktop-app::lib_crl
    desktop-app::lib_ui
    desktop-app::lib_tl
    desktop-app::lib_storage
    desktop-app::lib_lottie
    desktop-app::lib_qr
    desktop-app::lib_ffmpeg
    desktop-app::external_lz4
    desktop-app::external_rlottie
    desktop-app::external_zlib
    desktop-app::external_qt
    desktop-app::external_qr_code_generator
    desktop-app::external_crash_reports
    desktop-app::external_auto_updates
    tdesktop::lib_tgvoip
    desktop-app::external_openssl
    desktop-app::external_openal
)

if (NOT DESKTOP_APP_USE_PACKAGED)
    target_link_libraries(Telegram PRIVATE desktop-app::external_opus)
endif()

# Telegram uses long atomic types, so on some architectures libatomic is needed.
check_cxx_source_compiles("
#include <atomic>
std::atomic_int64_t foo;
int main() {return foo;}
" HAVE_LONG_ATOMIC_WITHOUT_LIB)
if (NOT HAVE_LONG_ATOMIC_WITHOUT_LIB)
    target_link_libraries(Telegram PRIVATE atomic)
endif()

target_precompile_headers(Telegram PRIVATE ${src_loc}/stdafx.h)
nice_target_sources(Telegram ${src_loc}
PRIVATE
    ${style_files}

    api/api_common.h
    api/api_hash.h
    api/api_self_destruct.cpp
    api/api_self_destruct.h
    api/api_sending.cpp
    api/api_sending.h
    api/api_sensitive_content.cpp
    api/api_sensitive_content.h
    api/api_single_message_search.cpp
    api/api_single_message_search.h
    api/api_text_entities.cpp
    api/api_text_entities.h
    boxes/peers/add_participants_box.cpp
    boxes/peers/add_participants_box.h
    boxes/peers/edit_contact_box.cpp
    boxes/peers/edit_contact_box.h
    boxes/peers/edit_linked_chat_box.cpp
    boxes/peers/edit_linked_chat_box.h
    boxes/peers/edit_participant_box.cpp
    boxes/peers/edit_participant_box.h
    boxes/peers/edit_participants_box.cpp
    boxes/peers/edit_participants_box.h
    boxes/peers/edit_peer_info_box.cpp
    boxes/peers/edit_peer_info_box.h
    boxes/peers/edit_peer_type_box.cpp
    boxes/peers/edit_peer_type_box.h
    boxes/peers/edit_peer_history_visibility_box.cpp
    boxes/peers/edit_peer_history_visibility_box.h
    boxes/peers/edit_peer_permissions_box.cpp
    boxes/peers/edit_peer_permissions_box.h
    boxes/about_box.cpp
    boxes/about_box.h
    boxes/abstract_box.cpp
    boxes/abstract_box.h
    boxes/add_contact_box.cpp
    boxes/add_contact_box.h
    boxes/auto_lock_box.cpp
    boxes/auto_lock_box.h
    boxes/auto_download_box.cpp
    boxes/auto_download_box.h
    boxes/background_box.cpp
    boxes/background_box.h
    boxes/background_preview_box.cpp
    boxes/background_preview_box.h
    boxes/calendar_box.cpp
    boxes/calendar_box.h
    boxes/change_phone_box.cpp
    boxes/change_phone_box.h
    boxes/confirm_box.cpp
    boxes/confirm_box.h
    boxes/confirm_phone_box.cpp
    boxes/confirm_phone_box.h
    boxes/connection_box.cpp
    boxes/connection_box.h
    boxes/create_poll_box.cpp
    boxes/create_poll_box.h
    boxes/download_path_box.cpp
    boxes/download_path_box.h
    boxes/edit_caption_box.cpp
    boxes/edit_caption_box.h
    boxes/edit_color_box.cpp
    boxes/edit_color_box.h
    boxes/edit_privacy_box.cpp
    boxes/edit_privacy_box.h
    boxes/language_box.cpp
    boxes/language_box.h
    boxes/local_storage_box.cpp
    boxes/local_storage_box.h
    boxes/mute_settings_box.cpp
    boxes/mute_settings_box.h
    boxes/peer_list_box.cpp
    boxes/peer_list_box.h
    boxes/peer_list_controllers.cpp
    boxes/peer_list_controllers.h
    boxes/passcode_box.cpp
    boxes/passcode_box.h
    boxes/photo_crop_box.cpp
    boxes/photo_crop_box.h
    boxes/rate_call_box.cpp
    boxes/rate_call_box.h
    boxes/report_box.cpp
    boxes/report_box.h
    boxes/self_destruction_box.cpp
    boxes/self_destruction_box.h
    boxes/send_files_box.cpp
    boxes/send_files_box.h
    boxes/sessions_box.cpp
    boxes/sessions_box.h
    boxes/share_box.cpp
    boxes/share_box.h
    boxes/single_choice_box.cpp
    boxes/single_choice_box.h
    boxes/sticker_set_box.cpp
    boxes/sticker_set_box.h
    boxes/stickers_box.cpp
    boxes/stickers_box.h
    boxes/url_auth_box.cpp
    boxes/url_auth_box.h
    boxes/username_box.cpp
    boxes/username_box.h
    calls/calls_box_controller.cpp
    calls/calls_box_controller.h
    calls/calls_call.cpp
    calls/calls_call.h
    calls/calls_emoji_fingerprint.cpp
    calls/calls_emoji_fingerprint.h
    calls/calls_instance.cpp
    calls/calls_instance.h
    calls/calls_panel.cpp
    calls/calls_panel.h
    calls/calls_top_bar.cpp
    calls/calls_top_bar.h
    chat_helpers/bot_keyboard.cpp
    chat_helpers/bot_keyboard.h
    chat_helpers/emoji_keywords.cpp
    chat_helpers/emoji_keywords.h
    chat_helpers/emoji_list_widget.cpp
    chat_helpers/emoji_list_widget.h
    chat_helpers/emoji_sets_manager.cpp
    chat_helpers/emoji_sets_manager.h
    chat_helpers/emoji_suggestions_widget.cpp
    chat_helpers/emoji_suggestions_widget.h
    chat_helpers/field_autocomplete.cpp
    chat_helpers/field_autocomplete.h
    chat_helpers/gifs_list_widget.cpp
    chat_helpers/gifs_list_widget.h
    chat_helpers/message_field.cpp
    chat_helpers/message_field.h
    chat_helpers/stickers.cpp
    chat_helpers/stickers.h
    chat_helpers/stickers_emoji_pack.cpp
    chat_helpers/stickers_emoji_pack.h
    chat_helpers/stickers_list_widget.cpp
    chat_helpers/stickers_list_widget.h
    chat_helpers/tabbed_panel.cpp
    chat_helpers/tabbed_panel.h
    chat_helpers/tabbed_section.cpp
    chat_helpers/tabbed_section.h
    chat_helpers/tabbed_selector.cpp
    chat_helpers/tabbed_selector.h
    core/application.cpp
    core/application.h
    core/base_integration.cpp
    core/base_integration.h
    core/changelogs.cpp
    core/changelogs.h
    core/click_handler_types.cpp
    core/click_handler_types.h
    core/core_cloud_password.cpp
    core/core_cloud_password.h
    core/core_settings.cpp
    core/core_settings.h
    core/crash_report_window.cpp
    core/crash_report_window.h
    core/crash_reports.cpp
    core/crash_reports.h
    core/file_utilities.cpp
    core/file_utilities.h
    core/launcher.cpp
    core/launcher.h
    core/local_url_handlers.cpp
    core/local_url_handlers.h
    core/media_active_cache.h
    core/mime_type.cpp
    core/mime_type.h
    core/sandbox.cpp
    core/sandbox.h
    core/shortcuts.cpp
    core/shortcuts.h
    core/ui_integration.cpp
    core/ui_integration.h
    core/update_checker.cpp
    core/update_checker.h
    core/utils.cpp
    core/utils.h
    core/version.h
    data/data_abstract_structure.cpp
    data/data_abstract_structure.h
    data/data_auto_download.cpp
    data/data_auto_download.h
    data/data_chat.cpp
    data/data_chat.h
    data/data_channel.cpp
    data/data_channel.h
    data/data_channel_admins.cpp
    data/data_channel_admins.h
    data/data_cloud_themes.cpp
    data/data_cloud_themes.h
    data/data_countries.cpp
    data/data_countries.h
    data/data_document.cpp
    data/data_document.h
    data/data_document_good_thumbnail.cpp
    data/data_document_good_thumbnail.h
    data/data_drafts.cpp
    data/data_drafts.h
    data/data_folder.cpp
    data/data_folder.h
    # data/data_feed_messages.cpp
    # data/data_feed_messages.h
    data/data_file_origin.cpp
    data/data_file_origin.h
    data/data_flags.h
    data/data_game.h
    data/data_groups.cpp
    data/data_groups.h
    data/data_location.cpp
    data/data_location.h
    data/data_media_rotation.cpp
    data/data_media_rotation.h
    data/data_media_types.cpp
    data/data_media_types.h
    data/data_messages.cpp
    data/data_messages.h
    data/data_notify_settings.cpp
    data/data_notify_settings.h
    data/data_peer.cpp
    data/data_peer.h
    data/data_peer_values.cpp
    data/data_peer_values.h
    data/data_photo.cpp
    data/data_photo.h
    data/data_poll.cpp
    data/data_poll.h
    data/data_pts_waiter.cpp
    data/data_pts_waiter.h
    data/data_search_controller.cpp
    data/data_search_controller.h
    data/data_session.cpp
    data/data_session.h
    data/data_scheduled_messages.cpp
    data/data_scheduled_messages.h
    data/data_shared_media.cpp
    data/data_shared_media.h
    data/data_sparse_ids.cpp
    data/data_sparse_ids.h
    data/data_streaming.cpp
    data/data_streaming.h
    data/data_types.cpp
    data/data_types.h
    data/data_user.cpp
    data/data_user.h
    data/data_user_photos.cpp
    data/data_user_photos.h
    data/data_wall_paper.cpp
    data/data_wall_paper.h
    data/data_web_page.cpp
    data/data_web_page.h
    dialogs/dialogs_entry.cpp
    dialogs/dialogs_entry.h
    dialogs/dialogs_indexed_list.cpp
    dialogs/dialogs_indexed_list.h
    dialogs/dialogs_inner_widget.cpp
    dialogs/dialogs_inner_widget.h
    dialogs/dialogs_key.cpp
    dialogs/dialogs_key.h
    dialogs/dialogs_layout.cpp
    dialogs/dialogs_layout.h
    dialogs/dialogs_list.cpp
    dialogs/dialogs_list.h
    dialogs/dialogs_main_list.cpp
    dialogs/dialogs_main_list.h
    dialogs/dialogs_pinned_list.cpp
    dialogs/dialogs_pinned_list.h
    dialogs/dialogs_row.cpp
    dialogs/dialogs_row.h
    dialogs/dialogs_search_from_controllers.cpp
    dialogs/dialogs_search_from_controllers.h
    dialogs/dialogs_widget.cpp
    dialogs/dialogs_widget.h
    export/view/export_view_content.cpp
    export/view/export_view_content.h
    export/view/export_view_panel_controller.cpp
    export/view/export_view_panel_controller.h
    export/view/export_view_progress.cpp
    export/view/export_view_progress.h

=== Telegram/lib_spellcheck/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_spellcheck OBJECT)
add_library(desktop-app::lib_spellcheck ALIAS lib_spellcheck)
init_target(lib_spellcheck)

get_filename_component(src_loc . REALPATH)

target_precompile_headers(lib_spellcheck PRIVATE ${src_loc}/spellcheck/spellcheck_pch.h)
nice_target_sources(lib_spellcheck ${src_loc}
PRIVATE
    spellcheck/platform/platform_spellcheck.h
    spellcheck/platform/linux/linux_enchant.cpp
    spellcheck/platform/linux/linux_enchant.h
    spellcheck/platform/linux/spellcheck_linux.cpp
    spellcheck/platform/linux/spellcheck_linux.h
    spellcheck/platform/mac/spellcheck_mac.h
    spellcheck/platform/mac/spellcheck_mac.mm
    spellcheck/platform/win/spellcheck_win.cpp
    spellcheck/platform/win/spellcheck_win.h
    spellcheck/spellcheck_utils.cpp
    spellcheck/spellcheck_utils.h
    spellcheck/spellcheck_types.h
    spellcheck/spelling_highlighter.cpp
    spellcheck/spelling_highlighter.h
)

target_include_directories(lib_spellcheck
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_spellcheck
PUBLIC
    desktop-app::lib_ui
)

if (LINUX)
    find_package(PkgConfig REQUIRED)

    pkg_search_module(ENCHANT REQUIRED enchant-2 enchant)
    target_include_directories(lib_spellcheck PRIVATE ${ENCHANT_INCLUDE_DIRS})
endif()

=== cmake/external/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_subdirectory(auto_updates)
add_subdirectory(crash_reports)
if (LINUX)
    add_subdirectory(dbusmenu_qt)
endif()
add_subdirectory(expected)
add_subdirectory(ffmpeg)
add_subdirectory(gsl)
add_subdirectory(iconv)
add_subdirectory(lz4)
add_subdirectory(openal)
add_subdirectory(openssl)
add_subdirectory(opus)
add_subdirectory(qt)
add_subdirectory(qr_code_generator)
add_subdirectory(ranges)
add_subdirectory(rlottie)
if (APPLE)
    add_subdirectory(sp_media_key_tap)
endif()
if (LINUX)
    add_subdirectory(statusnotifieritem)
endif()
add_subdirectory(variant)
add_subdirectory(xxhash)
add_subdirectory(zlib)

=== cmake/external/dbusmenu_qt/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED)
    add_library(external_dbusmenu_qt INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_dbusmenu_qt ALIAS external_dbusmenu_qt)

    find_package(dbusmenu-qt5)

    if (dbusmenu-qt5_FOUND)
        target_link_libraries(external_dbusmenu_qt INTERFACE dbusmenu-qt5)
    endif()
else()
    add_library(external_dbusmenu_qt OBJECT)
    add_library(desktop-app::external_dbusmenu_qt ALIAS external_dbusmenu_qt)
    init_target(external_dbusmenu_qt "(external)")

    set(dbusmenu_qt_VERSION_MAJOR 0)
    set(dbusmenu_qt_VERSION_MINOR 9)
    set(dbusmenu_qt_VERSION_PATCH 2)

    set(dbusmenu_qt_loc ${third_party_loc}/libdbusmenu-qt/src)

    set_target_properties(external_dbusmenu_qt PROPERTIES AUTOMOC ON)

    # QIcon::name was introduced in Qt 4.7.
    set(HAVE_QICON_NAME ON)

    configure_file(${dbusmenu_qt_loc}/dbusmenu_config.h.in "${CMAKE_CURRENT_BINARY_DIR}/dbusmenu_config.h" @ONLY)
    configure_file(${dbusmenu_qt_loc}/dbusmenu_version.h.in "${CMAKE_CURRENT_BINARY_DIR}/dbusmenu_version.h")

    nice_target_sources(external_dbusmenu_qt ${dbusmenu_qt_loc}
    PRIVATE
        dbusmenu_p.cpp
        dbusmenuexporter.cpp
        dbusmenuexporterdbus_p.cpp
        dbusmenuimporter.cpp
        dbusmenutypes_p.cpp
        dbusmenushortcut_p.cpp
        utils.cpp
    )

    qt5_add_dbus_adaptor(dbusmenu_adaptor
        ${dbusmenu_qt_loc}/com.canonical.dbusmenu.xml
        ${dbusmenu_qt_loc}/dbusmenuexporterdbus_p.h
        DBusMenuExporterDBus
    )

    target_sources(external_dbusmenu_qt PRIVATE ${dbusmenu_adaptor})

    target_include_directories(external_dbusmenu_qt
    PUBLIC
        ${dbusmenu_qt_loc}
        "${CMAKE_CURRENT_BINARY_DIR}")

    target_link_libraries(external_dbusmenu_qt
    PUBLIC
        desktop-app::external_qt
    )
endif()

=== cmake/external/qt/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_qt INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_qt ALIAS external_qt)

if (LINUX)
    if (NOT build_linux32)
        target_compile_definitions(external_qt INTERFACE Q_OS_LINUX64)
    else()
        target_compile_definitions(external_qt INTERFACE Q_OS_LINUX32)
    endif()
endif()

if (DESKTOP_APP_USE_PACKAGED)
    target_link_libraries(external_qt
    INTERFACE
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::Network)

    if (Qt5DBus_FOUND)
        target_link_libraries(external_qt INTERFACE Qt5::DBus)
    endif()

    target_include_directories(external_qt
    INTERFACE
        ${Qt5Core_PRIVATE_INCLUDE_DIRS}
        ${Qt5Gui_PRIVATE_INCLUDE_DIRS})
else()
    target_include_directories(external_qt SYSTEM
    INTERFACE
        ${qt_loc}/include
        ${qt_loc}/include/QtCore
        ${qt_loc}/include/QtGui
        ${qt_loc}/include/QtWidgets
        ${qt_loc}/include/QtCore/${qt_version}
        ${qt_loc}/include/QtGui/${qt_version}
        ${qt_loc}/include/QtCore/${qt_version}/QtCore
        ${qt_loc}/include/QtGui/${qt_version}/QtGui
    )

    if (Qt5DBus_FOUND)
        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${qt_loc}/include/QtDBus
        )
    endif()

    target_compile_definitions(external_qt
    INTERFACE
        _REENTRANT
        QT_STATICPLUGIN
        QT_PLUGIN
        QT_WIDGETS_LIB
        QT_NETWORK_LIB
        QT_GUI_LIB
        QT_CORE_LIB
    )

    if (WIN32)
        set(qt_lib_prefix "")
        set(qt_lib_suffix $<$<CONFIG:Debug>:d>.lib)
    else()
        set(qt_lib_prefix lib)
        if (APPLE)
            set(qt_lib_suffix $<$<CONFIG:Debug>:_debug>.a)
        else()
            set(qt_lib_suffix .a)
        endif()
    endif()

    set(common_qt_libs
        plugins/imageformats/${qt_lib_prefix}qwebp
        plugins/imageformats/${qt_lib_prefix}qgif
        plugins/imageformats/${qt_lib_prefix}qjpeg
        lib/${qt_lib_prefix}Qt5PrintSupport
        lib/${qt_lib_prefix}Qt5AccessibilitySupport
        lib/${qt_lib_prefix}Qt5FontDatabaseSupport
        lib/${qt_lib_prefix}Qt5EventDispatcherSupport
        lib/${qt_lib_prefix}Qt5ThemeSupport
        lib/${qt_lib_prefix}Qt5Network
        lib/${qt_lib_prefix}Qt5Widgets
        lib/${qt_lib_prefix}Qt5Gui
        lib/${qt_lib_prefix}qtharfbuzz
        lib/${qt_lib_prefix}qtlibpng
    )

    set(qt_libs_list "")
    if (WIN32)
        set(qt_libs
            ${common_qt_libs}
            lib/${qt_lib_prefix}Qt5Core
            lib/${qt_lib_prefix}Qt5WindowsUIAutomationSupport
            lib/${qt_lib_prefix}qtmain
            lib/${qt_lib_prefix}qtfreetype
            lib/${qt_lib_prefix}qtpcre2
            plugins/platforms/${qt_lib_prefix}qwindows
        )
        foreach (lib ${qt_libs})
            list(APPEND qt_libs_list "${qt_loc}/${lib}${qt_lib_suffix}")
        endforeach()
    elseif (APPLE)
        if (NOT build_osx)
            set(qt_libs
                ${common_qt_libs}
                lib/${qt_lib_prefix}Qt5Core
                lib/${qt_lib_prefix}Qt5GraphicsSupport
                lib/${qt_lib_prefix}Qt5ClipboardSupport
                lib/${qt_lib_prefix}qtfreetype
                lib/${qt_lib_prefix}qtpcre2
                plugins/platforms/${qt_lib_prefix}qcocoa
                plugins/bearer/${qt_lib_prefix}qgenericbearer
            )
        else()
            set(qt_libs
                lib/${qt_lib_prefix}Qt5PrintSupport
                lib/${qt_lib_prefix}Qt5PlatformSupport
                lib/${qt_lib_prefix}Qt5Network
                lib/${qt_lib_prefix}Qt5Widgets
                lib/${qt_lib_prefix}Qt5Gui
                lib/${qt_lib_prefix}Qt5Core
                lib/${qt_lib_prefix}qtharfbuzzng
                lib/${qt_lib_prefix}qtfreetype
                lib/${qt_lib_prefix}qtpcre
                plugins/platforms/${qt_lib_prefix}qcocoa
                plugins/imageformats/${qt_lib_prefix}qwebp
                plugins/bearer/${qt_lib_prefix}qgenericbearer
            )
        endif()
        foreach (lib ${qt_libs})
            list(APPEND qt_libs_list "${qt_loc}/${lib}${qt_lib_suffix}")
        endforeach()
        target_link_libraries(external_qt
        INTERFACE
            desktop-app::external_zlib
            cups
        )
    else()
        if (Qt5DBus_FOUND)
            set(qt_libs_dbus lib/${qt_lib_prefix}Qt5DBus)
            set(qt_libs_dbus_plugins
                plugins/platforminputcontexts/${qt_lib_prefix}ibusplatforminputcontextplugin
                plugins/platforminputcontexts/${qt_lib_prefix}fcitxplatforminputcontextplugin
                plugins/platforminputcontexts/${qt_lib_prefix}himeplatforminputcontextplugin
                plugins/platforminputcontexts/${qt_lib_prefix}nimfplatforminputcontextplugin
                plugins/platformthemes/${qt_lib_prefix}qxdgdesktopportal
            )
            set(qt_libs_dbus_bearers
                plugins/bearer/${qt_lib_prefix}qconnmanbearer
                plugins/bearer/${qt_lib_prefix}qnmbearer
            )
        endif()
        set(qt_libs
            plugins/platforminputcontexts/${qt_lib_prefix}composeplatforminputcontextplugin
            ${qt_libs_dbus_plugins}
            plugins/platforms/${qt_lib_prefix}qxcb
            plugins/iconengines/${qt_lib_prefix}qsvgicon
            lib/${qt_lib_prefix}Qt5XcbQpa
            lib/${qt_lib_prefix}Qt5LinuxAccessibilitySupport
            lib/${qt_lib_prefix}Qt5ServiceSupport
            lib/${qt_lib_prefix}Qt5EdidSupport
            plugins/bearer/${qt_lib_prefix}qgenericbearer
            ${qt_libs_dbus_bearers}
            ${common_qt_libs}
            ${qt_libs_dbus}
            lib/${qt_lib_prefix}Qt5Svg
            lib/${qt_lib_prefix}Qt5Core
            lib/${qt_lib_prefix}qtpcre2
            lib/${qt_lib_prefix}xcb-static
        )
        foreach (lib ${qt_libs})
            list(APPEND qt_libs_list "${qt_loc}/${lib}${qt_lib_suffix}")
        endforeach()
    endif()

    target_link_libraries(external_qt
    INTERFACE
        ${qt_libs_list}
    )

    if (LINUX)
        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${qt_loc}/mkspecs/linux-g++
        )
        target_link_options(external_qt
        INTERFACE
            -static-libstdc++
            -pthread
            -rdynamic
        )
        if (DESKTOP_APP_USE_GLIBC_WRAPS)
            target_link_options(external_qt
            INTERFACE
                -Wl,-wrap,aligned_alloc
                -Wl,-wrap,secure_getenv
                -Wl,-wrap,clock_gettime
                -Wl,--no-as-needed,-lrt
            )
            if (NOT build_linux32)
                target_link_options(external_qt
                INTERFACE
                    -Wl,-wrap,__divmodti4
                )
            else()
                target_link_options(external_qt
                INTERFACE
                    -Wl,-wrap,__divmoddi4
                )
            endif()
        endif()
        target_link_static_libraries(external_qt
        INTERFACE
            xcb-shm
            xcb-xfixes
            xcb-render
            xkbcommon
            xkbcommon-x11
            Xrender
            icutu
            icui18n
            icuuc
            icudata
        )
        if (DESKTOP_APP_USE_GLIBC_WRAPS)
            target_link_libraries(external_qt
            INTERFACE
                desktop-app::linux_glibc_wraps
                $<TARGET_FILE:desktop-app::linux_glibc_wraps>
            )
        endif()
        target_link_libraries(external_qt
        INTERFACE
            ICE
            SM
            fontconfig
            freetype
            xcb
            X11
            X11-xcb
            dl
            glib-2.0
            pthread
        )
        find_library(DBUS_LIBRARY dbus-1)
        if (Qt5DBus_FOUND AND DBUS_LIBRARY)
            target_link_libraries(external_qt INTERFACE dbus-1)
        endif()
    endif()
endif()

=== cmake/external/rlottie/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED_RLOTTIE)
    add_library(external_rlottie INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_rlottie ALIAS external_rlottie)

    find_package(PkgConfig REQUIRED)
    pkg_check_modules(RLOTTIE REQUIRED rlottie)
    target_include_directories(external_rlottie INTERFACE ${RLOTTIE_INCLUDE_DIRS})
    target_link_libraries(external_rlottie INTERFACE ${RLOTTIE_LIBRARIES})
else()
    add_library(external_rlottie OBJECT)
    add_library(desktop-app::external_rlottie ALIAS external_rlottie)
    init_target(external_rlottie "(external)")

    get_filename_component(src_loc . REALPATH)
    set(rlottie_loc ${third_party_loc}/rlottie)

    target_sources(external_rlottie PRIVATE ${src_loc}/config/config.h)
    nice_target_sources(external_rlottie ${rlottie_loc}
    PRIVATE
        inc/rlottie.h
        inc/rlottie_capi.h
        inc/rlottiecommon.h

        src/lottie/lottieanimation.cpp
        src/lottie/lottieitem.cpp
        src/lottie/lottieitem.h
        src/lottie/lottiekeypath.cpp
        src/lottie/lottiekeypath.h
        src/lottie/lottieloader.cpp
        src/lottie/lottieloader.h
        src/lottie/lottiemodel.cpp
        src/lottie/lottiemodel.h
        src/lottie/lottieparser.cpp
        src/lottie/lottieparser.h
        src/lottie/lottieproxymodel.cpp
        src/lottie/lottieproxymodel.h

        src/vector/freetype/v_ft_math.cpp
        src/vector/freetype/v_ft_math.h
        src/vector/freetype/v_ft_raster.cpp
        src/vector/freetype/v_ft_raster.h
        src/vector/freetype/v_ft_stroker.cpp
        src/vector/freetype/v_ft_stroker.h
        src/vector/freetype/v_ft_types.h

        # src/vector/pixman/pixman-arm-neon-asm.h
        # src/vector/pixman/pixman-arm-neon-asm.S
        src/vector/pixman/vregion.cpp
        src/vector/pixman/vregion.h

        src/vector/vbezier.cpp
        src/vector/vbezier.h
        src/vector/vbitmap.cpp
        src/vector/vbitmap.h
        src/vector/vbrush.cpp
        src/vector/vbrush.h
        src/vector/vcompositionfunctions.cpp
        src/vector/vcowptr.h
        src/vector/vdasher.cpp
        src/vector/vdasher.h
        src/vector/vdebug.cpp
        src/vector/vdebug.h
        src/vector/vdrawable.cpp
        src/vector/vdrawable.h
        src/vector/vdrawhelper.cpp
        src/vector/vdrawhelper.h
        src/vector/vdrawhelper_neon.cpp
        src/vector/vdrawhelper_sse2.cpp
        src/vector/velapsedtimer.cpp
        src/vector/velapsedtimer.h
        src/vector/vglobal.h
        src/vector/vimageloader.cpp
        src/vector/vimageloader.h
        src/vector/vinterpolator.cpp
        src/vector/vinterpolator.h
        src/vector/vline.h
        src/vector/vmatrix.cpp
        src/vector/vmatrix.h
        src/vector/vpainter.cpp
        src/vector/vpainter.h
        src/vector/vpath.cpp
        src/vector/vpath.h
        src/vector/vpathmesure.cpp
        src/vector/vpathmesure.h
        src/vector/vpoint.h
        src/vector/vraster.cpp
        src/vector/vraster.h
        src/vector/vrect.cpp
        src/vector/vrect.h
        src/vector/vrle.cpp
        src/vector/vrle.h
        src/vector/vstackallocator.h
        src/vector/vtaskqueue.h
    )

    target_compile_definitions(external_rlottie
    PUBLIC
        LOT_BUILD
    PRIVATE
        _USE_MATH_DEFINES
        LOTTIE_DISABLE_ARM_NEON
        "RAPIDJSON_ASSERT=(void)"
    )

    target_include_directories(external_rlottie
    PUBLIC
        ${rlottie_loc}/inc
    PRIVATE
        ${src_loc}/config
        ${rlottie_loc}/src/lottie
        ${rlottie_loc}/src/vector
        ${rlottie_loc}/src/vector/pixman
        ${rlottie_loc}/src/vector/freetype
    )

    if (WIN32)
        target_compile_options(external_rlottie
        PRIVATE
            /w44244 # 'initializing': conversion from 'double' to 'float'
            /w44251 # needs to have dll-interface to be used by clients of class
        )
    endif()
endif()

=== cmake/external/zlib/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_zlib INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_zlib ALIAS external_zlib)

if (DESKTOP_APP_USE_PACKAGED)
    add_library(external_minizip INTERFACE IMPORTED)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(MINIZIP REQUIRED minizip)

    target_include_directories(external_minizip INTERFACE ${MINIZIP_INCLUDE_DIRS})
    target_link_libraries(external_minizip INTERFACE ${MINIZIP_LIBRARIES})

    target_link_libraries(external_zlib INTERFACE external_minizip)
elseif (NOT WIN32)
    add_library(external_minizip STATIC)
    init_target(external_minizip "(external)")

    set(minizip_loc ${third_party_loc}/minizip)

    target_sources(external_minizip
    PRIVATE
        ${minizip_loc}/crypt.h
        ${minizip_loc}/ioapi.c
        ${minizip_loc}/ioapi.h
        ${minizip_loc}/zip.c
        ${minizip_loc}/zip.h
        ${minizip_loc}/unzip.c
        ${minizip_loc}/unzip.h
    )

    target_include_directories(external_minizip SYSTEM
    INTERFACE
        ${minizip_loc}
    )

    target_link_libraries(external_zlib INTERFACE external_minizip)
endif()

if (NOT DESKTOP_APP_USE_PACKAGED AND NOT LINUX)
    target_include_directories(external_zlib SYSTEM
    INTERFACE
        ${libs_loc}/zlib
        ${libs_loc}/zlib/contrib/minizip
    )
endif()

if (DESKTOP_APP_USE_PACKAGED)
    find_package(ZLIB REQUIRED)
    target_link_libraries(external_zlib INTERFACE ZLIB::ZLIB)
elseif (WIN32)
    target_compile_definitions(external_zlib INTERFACE ZLIB_WINAPI)

    set(zlib_lib_loc ${libs_loc}/zlib/contrib/vstudio/vc14/x86/ZlibStat$<IF:$<CONFIG:Debug>,Debug,ReleaseWithoutAsm>)

    target_link_libraries(external_zlib INTERFACE ${zlib_lib_loc}/zlibstat.lib)
elseif (APPLE AND NOT build_osx)
    target_link_libraries(external_zlib INTERFACE /usr/local/macos/lib/libz.a)
elseif (APPLE)
    target_link_libraries(external_zlib INTERFACE /usr/local/lib/libz.a)
else()
    target_link_libraries(external_zlib INTERFACE z)
endif()

=== debian/changelog ===
telegram-desktop (1.9.14+ds-2) unstable; urgency=medium

  [ Ilya Fedin ]
  * Add category property for StatusNotifierItem, this fixes tray icon in
    KDE Plasma 5 and Cinnamon. (Closes: #951810)

  [ Nicholas Guriev ]
  * Mend a hack for non-Linux systems to fix build for GNU/Hurd or FreeBSD.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 24 Feb 2020 07:54:56 +0300

telegram-desktop (1.9.14+ds-1) unstable; urgency=medium

  * New upstream release.
  * Import StatusNotifierItem from lxqt-qtplugin v0.14.0.
  * Adjust patches and build rules.
    - No install tg.protocol file for KDE4.
    - New build dependency: libdbusmenu-qt5-dev
  * Exclude HP/PA and Motorola 68k from list of supported architectures.
  * Decrease required Qt version to 5.9, this is minimal tested version.
  * Bump Standards-Version to 4.5.0, no related changes.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 20 Feb 2020 08:45:20 +0300

=== debian/control ===
Source: telegram-desktop
Section: net
Priority: optional
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (=12)
Build-Depends-Arch:
 cmake (>=3.16.0),
 libavcodec-dev (>=7:3.2),
 libavformat-dev (>=7:3.2),
 libayatana-appindicator3-dev | libayatana-appindicator-dev | libappindicator3-dev | libappindicator-dev,
 libdbusmenu-qt5-dev,
 libenchant-dev | libenchant-2-dev,
 libexpected-dev,
 libgtk2.0-dev,
 liblz4-dev,
 liblzma-dev,
 libmapbox-variant-dev,
 libminizip-dev (>=1.1),
 libmsgsl-dev (>=1.0.0), libmsgsl-dev (<<2.0.0) | libmsgsl-dev (>=2.1.0),
 libopenal-dev,
 libopus-dev (>=1.1),
 libqrcodegencpp-dev,
 librange-v3-dev (>=0.10.0),
 librlottie-dev,
 libssl-dev (>=1.0.1),
 libswscale-dev (>=7:3.2),
 libtgvoip-dev (>=2.4.4),
 libxxhash-dev,
 qtbase5-dev (>=5.9.0),
 qtbase5-private-dev (>=5.9.0),
 zlib1g-dev (>=1:1.2.8),
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://desktop.telegram.org
Vcs-Git: https://salsa.debian.org/debian/telegram-desktop.git
Vcs-Browser: https://salsa.debian.org/debian/telegram-desktop

Package: telegram-desktop
# Only little endian is supported.
Architecture: amd64 arm64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64el mipsel ppc64el riscv64 sh4 x32
Depends: qt5-image-formats-plugins (>=5.9.0), ${misc:Depends}, ${shlibs:Depends}
Recommends: fonts-open-sans
Built-Using: ${cpplibs:Built-Using}
Description: fast and secure messaging application
 Telegram is a messaging app with a focus on speed and security, it is
 super-fast, simple and free. You can use Telegram on all your devices at the
 same time — your messages sync seamlessly across any number of your phones,
 tablets or computers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
include /usr/share/dpkg/default.mk

EXTRA_CMAKE_VARIABLES += \
	TDESKTOP_API_ID=50322 \
	TDESKTOP_API_HASH=9ff1a639196c0779c86dd661af8522ba \
	TDESKTOP_FORCE_GTK_FILE_DIALOG=ON \
	DESKTOP_APP_USE_PACKAGED_QRCODE=ON \
	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON \
	third_party_loc=$(CURDIR)/debian

ifeq ($(filter terse,$(DEB_BUILD_OPTIONS)),)
 EXTRA_CMAKE_VARIABLES += CMAKE_AUTOGEN_VERBOSE=ON
endif

ifneq ($(DEB_HOST_ARCH_OS),linux)
 # Mimic Linux on non-Linux hosts.
 export DEB_CPPFLAGS_MAINT_APPEND = -DQ_OS_LINUX
endif

CPPLIBS_PACKAGES = libexpected-dev libmapbox-variant-dev libmsgsl-dev librange-v3-dev libtgvoip-dev
EXTRA_SUBSTVARS += \
	cpplibs:Built-Using=$(shell dpkg-query -Wf '$${source:Package}(=$${Version}),' $(CPPLIBS_PACKAGES))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Make debugging a little easier. https://stackoverflow.com/a/25817631/5000805
print-%:
	@echo $* = $($*)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

override_dh_installchangelogs:
	dh_installchangelogs changelog.txt

# Double up the limit of debug information entries.
override_dh_dwz:
	dh_dwz -- -L 100000000

override_dh_gencontrol:
	dh_gencontrol -- $(EXTRA_SUBSTVARS:%="-V%")

## telegram-desktop 1.9.19+ds

=== Telegram/CMakeLists.txt ===
--- 
+++ 
@@ -66,23 +66,16 @@
 
 set_target_properties(Telegram PROPERTIES AUTOMOC ON AUTORCC ON)
 
-if (DESKTOP_APP_USE_PACKAGED)
-    set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
-    find_package(Threads)
-
-    target_link_libraries(Telegram
-    PRIVATE
-        ${CMAKE_DL_LIBS}
-        Threads::Threads
-    )
-endif()
-
-if (LINUX AND NOT TDESKTOP_DISABLE_DBUS_INTEGRATION)
+if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
     target_link_libraries(Telegram
     PRIVATE
         desktop-app::external_statusnotifieritem
         desktop-app::external_dbusmenu_qt
     )
+endif()
+
+if (add_hunspell_library)
+    target_link_libraries(Telegram PRIVATE desktop-app::external_hunspell)
 endif()
 
 target_link_libraries(Telegram
@@ -122,6 +115,17 @@
 " HAVE_LONG_ATOMIC_WITHOUT_LIB)
 if (NOT HAVE_LONG_ATOMIC_WITHOUT_LIB)
     target_link_libraries(Telegram PRIVATE atomic)
+endif()
+
+if (DESKTOP_APP_USE_PACKAGED)
+    set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
+    find_package(Threads)
+
+    target_link_libraries(Telegram
+    PRIVATE
+        ${CMAKE_DL_LIBS}
+        Threads::Threads
+    )
 endif()
 
 target_precompile_headers(Telegram PRIVATE ${src_loc}/stdafx.h)
@@ -185,6 +189,8 @@
     boxes/connection_box.h
     boxes/create_poll_box.cpp
     boxes/create_poll_box.h
+    boxes/dictionaries_manager.cpp
+    boxes/dictionaries_manager.h
     boxes/download_path_box.cpp
     boxes/download_path_box.h
     boxes/edit_caption_box.cpp
@@ -257,6 +263,8 @@
     chat_helpers/gifs_list_widget.h
     chat_helpers/message_field.cpp
     chat_helpers/message_field.h
+    chat_helpers/spellchecker_common.cpp
+    chat_helpers/spellchecker_common.h
     chat_helpers/stickers.cpp
     chat_helpers/stickers.h
     chat_helpers/stickers_emoji_pack.cpp
@@ -335,6 +343,8 @@
     data/data_game.h
     data/data_groups.cpp
     data/data_groups.h
+    data/data_histories.cpp
+    data/data_histories.h
     data/data_location.cpp
     data/data_location.h
     data/data_media_rotation.cpp
@@ -397,11 +407,3 @@
     dialogs/dialogs_row.h
     dialogs/dialogs_search_from_controllers.cpp
     dialogs/dialogs_search_from_controllers.h
-    dialogs/dialogs_widget.cpp
-    dialogs/dialogs_widget.h
-    export/view/export_view_content.cpp
-    export/view/export_view_content.h
-    export/view/export_view_panel_controller.cpp
-    export/view/export_view_panel_controller.h
-    export/view/export_view_progress.cpp
-    export/view/export_view_progress.h

=== Telegram/lib_spellcheck/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_spellcheck OBJECT)
add_library(desktop-app::lib_spellcheck ALIAS lib_spellcheck)
init_target(lib_spellcheck)

get_filename_component(src_loc . REALPATH)

set(use_enchant 0)
if (LINUX AND DESKTOP_APP_USE_ENCHANT)
    set(use_enchant 1)
endif()

set(system_spellchecker 0)
if ((APPLE OR WIN32 OR use_enchant) AND NOT DESKTOP_APP_USE_HUNSPELL_ONLY)
    set(system_spellchecker 1)
endif()

target_precompile_headers(lib_spellcheck PRIVATE ${src_loc}/spellcheck/spellcheck_pch.h)
nice_target_sources(lib_spellcheck ${src_loc}
PRIVATE
    spellcheck/platform/platform_spellcheck.h
    spellcheck/spellcheck_utils.cpp
    spellcheck/spellcheck_utils.h
    spellcheck/spellcheck_types.h
    spellcheck/spelling_highlighter.cpp
    spellcheck/spelling_highlighter.h
    spellcheck/spellcheck_value.cpp
    spellcheck/spellcheck_value.h
)

if (system_spellchecker)
    nice_target_sources(lib_spellcheck ${src_loc}
    PRIVATE
        spellcheck/platform/linux/linux_enchant.cpp
        spellcheck/platform/linux/linux_enchant.h
        spellcheck/platform/linux/spellcheck_linux.cpp
        spellcheck/platform/linux/spellcheck_linux.h
        spellcheck/platform/mac/spellcheck_mac.h
        spellcheck/platform/mac/spellcheck_mac.mm
        spellcheck/platform/win/spellcheck_win.cpp
        spellcheck/platform/win/spellcheck_win.h
    )
else()
    nice_target_sources(lib_spellcheck ${src_loc}
    PRIVATE
        spellcheck/third_party/spellcheck_hunspell.cpp
        spellcheck/third_party/spellcheck_hunspell.h
    )
endif()

# We should support both types of spellchecker for Windows.
if (NOT system_spellchecker OR WIN32)
    nice_target_sources(lib_spellcheck ${src_loc}
    PRIVATE
        spellcheck/third_party/hunspell_controller.cpp
        spellcheck/third_party/hunspell_controller.h
    )
    target_link_libraries(lib_spellcheck PUBLIC desktop-app::external_hunspell)
endif()

target_include_directories(lib_spellcheck
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_spellcheck
PUBLIC
    desktop-app::lib_ui
)

if (LINUX AND use_enchant)
    find_package(PkgConfig REQUIRED)

    pkg_search_module(ENCHANT REQUIRED enchant-2 enchant)
    target_include_directories(lib_spellcheck PRIVATE ${ENCHANT_INCLUDE_DIRS})
endif()

=== cmake/external/CMakeLists.txt ===
--- 
+++ 
@@ -6,12 +6,15 @@
 
 add_subdirectory(auto_updates)
 add_subdirectory(crash_reports)
-if (LINUX)
+if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
     add_subdirectory(dbusmenu_qt)
 endif()
 add_subdirectory(expected)
 add_subdirectory(ffmpeg)
 add_subdirectory(gsl)
+if (add_hunspell_library)
+	add_subdirectory(hunspell)
+endif()
 add_subdirectory(iconv)
 add_subdirectory(lz4)
 add_subdirectory(openal)
@@ -24,7 +27,7 @@
 if (APPLE)
     add_subdirectory(sp_media_key_tap)
 endif()
-if (LINUX)
+if (LINUX AND NOT DESKTOP_APP_DISABLE_DBUS_INTEGRATION)
     add_subdirectory(statusnotifieritem)
 endif()
 add_subdirectory(variant)

=== debian/changelog ===
telegram-desktop (1.9.19+ds-0.1~mx19+1) mx; urgency=medium

  * New upstream release.
  * Refresh Unset-Qt-platform-theme.patch.
  * Add libhunspell-dev to BDs.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 11 Mar 2020 17:15:29 -0700

telegram-desktop (1.9.14+ds-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 20 Feb 2020 17:40:33 -0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: telegram-desktop
 Section: net
 Priority: optional
-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
 Build-Depends: debhelper-compat (=12)
 Build-Depends-Arch:
  cmake (>=3.16.0),
@@ -12,6 +13,7 @@
  libenchant-dev | libenchant-2-dev,
  libexpected-dev,
  libgtk2.0-dev,
+ libhunspell-dev,
  liblz4-dev,
  liblzma-dev,
  libmapbox-variant-dev,

=== debian/rules ===
--- 
+++ 
@@ -14,9 +14,9 @@
  EXTRA_CMAKE_VARIABLES += CMAKE_AUTOGEN_VERBOSE=ON
 endif
 
+# Workarounds for non-Linux systems
 ifneq ($(DEB_HOST_ARCH_OS),linux)
- # Mimic Linux on non-Linux hosts.
- export DEB_CPPFLAGS_MAINT_APPEND = -DQ_OS_LINUX
+ EXTRA_MACROS += Q_OS_LINUX  # brilliant bluff :)
 endif
 
 CPPLIBS_PACKAGES = libexpected-dev libmapbox-variant-dev libmsgsl-dev librange-v3-dev libtgvoip-dev
@@ -44,3 +44,6 @@
 
 override_dh_gencontrol:
 	dh_gencontrol -- $(EXTRA_SUBSTVARS:%="-V%")
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## telegram-desktop 1.9.21+ds

=== Telegram/CMakeLists.txt ===
--- 
+++ 
@@ -94,6 +94,7 @@
     desktop-app::external_lz4
     desktop-app::external_rlottie
     desktop-app::external_zlib
+    desktop-app::external_minizip
     desktop-app::external_qt
     desktop-app::external_qr_code_generator
     desktop-app::external_crash_reports
@@ -406,4 +407,3 @@
     dialogs/dialogs_row.cpp
     dialogs/dialogs_row.h
     dialogs/dialogs_search_from_controllers.cpp
-    dialogs/dialogs_search_from_controllers.h

=== cmake/external/hunspell/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED)
    add_library(external_hunspell INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_hunspell ALIAS external_hunspell)

    find_package(PkgConfig REQUIRED)
    pkg_check_modules(HUNSPELL REQUIRED hunspell)

    target_include_directories(external_hunspell INTERFACE ${HUNSPELL_INCLUDE_DIRS})
    target_link_libraries(external_hunspell INTERFACE ${HUNSPELL_LIBRARIES})
else()
    add_library(external_hunspell OBJECT)
    add_library(desktop-app::external_hunspell ALIAS external_hunspell)
    init_target(external_hunspell "(external)")

    set(hunspell_loc ${third_party_loc}/hunspell)
    set(hunspell_src ${hunspell_loc}/src)

    nice_target_sources(external_hunspell ${hunspell_src}
    PRIVATE
        hunspell/affentry.cxx
        hunspell/affentry.hxx
        hunspell/affixmgr.cxx
        hunspell/affixmgr.hxx
        hunspell/atypes.hxx
        hunspell/baseaffix.hxx
        hunspell/csutil.cxx
        hunspell/csutil.hxx
        hunspell/filemgr.cxx
        hunspell/filemgr.hxx
        hunspell/hashmgr.cxx
        hunspell/hashmgr.hxx
        hunspell/htypes.hxx
        hunspell/hunspell.cxx
        hunspell/hunspell.h
        hunspell/hunspell.hxx
        hunspell/hunvisapi.h
        hunspell/hunzip.cxx
        hunspell/hunzip.hxx
        hunspell/phonet.cxx
        hunspell/phonet.hxx
        hunspell/replist.cxx
        hunspell/replist.hxx
        hunspell/suggestmgr.cxx
        hunspell/suggestmgr.hxx
        hunspell/utf_info.hxx
    )

    target_include_directories(external_hunspell
    PUBLIC
        ${hunspell_src}
    )

    target_compile_definitions(external_hunspell
    PUBLIC
        HUNSPELL_STATIC
    )
endif()

=== debian/changelog ===
telegram-desktop (1.9.21+ds-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Make fonts-open-sans a dependency.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 25 Mar 2020 16:40:05 -0700

telegram-desktop (1.9.21+ds-1) unstable; urgency=medium

  * New upstream release.
    - Incremental reading of messages is available.
    - Spell-checker implementation remains the same via Enchant to make
      it easier for extension.
  * Add a script for reportbug that attaches user's log file.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 22 Mar 2020 08:57:48 +0300

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,16 @@
 Priority: optional
 Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
+# Build-Depends: debhelper (>=12.8~), debhelper-compat (=12)
 Build-Depends: debhelper-compat (=12)
 Build-Depends-Arch:
  cmake (>=3.16.0),
  libavcodec-dev (>=7:3.2),
  libavformat-dev (>=7:3.2),
- libayatana-appindicator3-dev | libayatana-appindicator-dev | libappindicator3-dev | libappindicator-dev,
  libdbusmenu-qt5-dev,
  libenchant-dev | libenchant-2-dev,
  libexpected-dev,
  libgtk2.0-dev,
- libhunspell-dev,
  liblz4-dev,
  liblzma-dev,
  libmapbox-variant-dev,
@@ -40,8 +39,11 @@
 Package: telegram-desktop
 # Only little endian is supported.
 Architecture: amd64 arm64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64el mipsel ppc64el riscv64 sh4 x32
-Depends: qt5-image-formats-plugins (>=5.9.0), ${misc:Depends}, ${shlibs:Depends}
-Recommends: fonts-open-sans
+Depends: qt5-image-formats-plugins (>=5.9.0),
+         ${misc:Depends},
+         ${shlibs:Depends},
+         fonts-open-sans
+# Recommends: fonts-open-sans
 Built-Using: ${cpplibs:Built-Using}
 Description: fast and secure messaging application
  Telegram is a messaging app with a focus on speed and security, it is

=== debian/rules ===
--- 
+++ 
@@ -6,17 +6,17 @@
 	TDESKTOP_API_ID=50322 \
 	TDESKTOP_API_HASH=9ff1a639196c0779c86dd661af8522ba \
 	TDESKTOP_FORCE_GTK_FILE_DIALOG=ON \
+	DESKTOP_APP_USE_ENCHANT=ON \
 	DESKTOP_APP_USE_PACKAGED_QRCODE=ON \
-	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON \
-	third_party_loc=$(CURDIR)/debian
+	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON
 
 ifeq ($(filter terse,$(DEB_BUILD_OPTIONS)),)
  EXTRA_CMAKE_VARIABLES += CMAKE_AUTOGEN_VERBOSE=ON
 endif
 
-# Workarounds for non-Linux systems
 ifneq ($(DEB_HOST_ARCH_OS),linux)
- EXTRA_MACROS += Q_OS_LINUX  # brilliant bluff :)
+ # Mimic Linux on non-Linux hosts.
+ export DEB_CPPFLAGS_MAINT_APPEND = -DQ_OS_LINUX
 endif
 
 CPPLIBS_PACKAGES = libexpected-dev libmapbox-variant-dev libmsgsl-dev librange-v3-dev libtgvoip-dev
@@ -33,7 +33,12 @@
 	dh $@
 
 override_dh_auto_configure:
+	ln -s -r debian Telegram/ThirdParty
 	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)
+
+# Remove symbolic link for access to StatusNotifierItem module.
+execute_after_dh_auto_clean:
+	rm -f Telegram/ThirdParty
 
 override_dh_installchangelogs:
 	dh_installchangelogs changelog.txt
